<template>
<section class="main-body-wrapper">
			<div class="container">
				<div class="page-title">
					<h1>Welcome to Jupiter Platform</h1>
					<h2 class="sub-title">Let’s start by verifying your contact information.</h2>
					<span class="title-detail">All fields having <i class="required-field" style="margin:0"></i> marked are required</span>
				</div>
				<div class="form-wrapper">
					<div class="container-fluid p-0">
						<form class="" v-on:submit.prevent="createAccount" > 
							<div class="row m-0">
								<div class="col-md-12">
									<div class="form-group">
										<label for="name" class="">
											<span>Full name</span>
											<i class="required-field float-left"></i>
										</label>
										<div class="input-wrapper">
											<input 
                          ref="fullname"
                          v-model.lazy="$v.name.$model"
                          type="text"
                          class="form-control"
                          :class="getValidationClass('name')"
                          id="full-name" 
                          placeholder="Full name" 
                          name="fullname"
                          >
                          <span class="success-icon"  v-if="$v.name.$dirty  && !$v.name.$invalid">
                             <i class="fa fa-check-circle" aria-hidden="true"></i>
                          </span>
                          <span class="error-icon" v-else-if="$v.name.$error">
                             <i class="fa fa-exclamation-triangle" aria-hidden="true"></i>
                          </span>
                        <i class="error-msg" v-if="$v.name.$dirty && !$v.name.required">Please enter Full name</i>
                        <i class="error-msg" v-else-if="$v.name.$dirty && !$v.name.minLength">Minimum 4 letters required</i>
                  	</div>
									</div>
								</div>
								<div class="col-md-12">
									<div class="form-group">
										<label for="email" class="">Email address
											<i class="required-field float-left"></i>
										</label>
										<div class="input-wrapper">
											<input 
                      v-model.lazy="$v.email.$model" 
                      type="email" 
                      class="form-control" 
                      :class="getValidationClass('email')"
                      id="email-address" 
                      placeholder="Email address" 
                      name="email">
                      <span class="success-icon"  v-if="$v.email.$dirty  && !$v.email.$invalid">
                            <i class="fa fa-check-circle" aria-hidden="true"></i>
                      </span>
                      <span class="error-icon" v-if="$v.email.$error">
                         <i class="fa fa-exclamation-triangle" aria-hidden="true"></i>
                      </span>
                      <i class="error-msg" v-if="$v.email.$dirty && !$v.email.required">Please enter Email</i>
                      <i class="error-msg" v-else-if="$v.email.$dirty && !$v.email.email">Enter valid email</i>
                    </div>
									</div>
								</div>
								<div class="col-md-12">
									<div class="form-group">
										<label for="mobile-number" class="">Mobile number
											<i class="required-field float-left"></i>
										</label>
										<div class="input-wrapper">
											<input 
                      v-model.lazy="$v.mobile.$model" 
                      v-mask="'##########'"
                      type="number"
                      class="form-control" 
                      :class="getValidationClass('mobile')"
                      id="mobile-number" 
                      placeholder="Mobile number" 
                      name="mobilenumber">
                       <span class="success-icon"  v-if="$v.mobile.$dirty  && !$v.mobile.$invalid">
                            <i class="fa fa-check-circle" aria-hidden="true"></i>
                      </span>
                      <span class="error-icon" v-if="$v.mobile.$error">
                         <i class="fa fa-exclamation-triangle" aria-hidden="true"></i>
                      </span>
                      <i class="error-msg" v-if="$v.mobile.$dirty && !$v.mobile.required">Please enter Mobile Number</i>
                      <i class="error-msg" v-else-if="$v.mobile.$dirty && !$v.mobile.minLength">Minimum 10 numbers required</i>
                  	</div>
									</div>
								</div>
								<div class="col-md-12">
									<div class="row">
										<div class="col-lg-6 col-md-12">
                      <div id="captcha-wrapper">
                        <vue-recaptcha @verify="onVerify" @expired="onExpired" sitekey="6LdthX0UAAAAAGCwzon8azaq5tsKfx6iefJIEjEk"></vue-recaptcha>
                         <i class="error-msg" v-if="$v.captcha.$error">Please verify that you are not a robot.</i>
                      </div>
										</div>
										<div class="col-lg-6 col-md-12">
											<div class="company-tnc-box">
												<div class="company-tnc-checkbox">
													<input v-model.lazy="$v.terms.$model" type="checkbox" name="">
												</div>
												<div class="company-tnc-links">
														<p>I accept <a href class="" data-toggle="modal" data-target="#termandservice">Terms of Service</a>, <a  href  data-toggle="modal" data-target="#payment-term">Payment Terms</a> & <a href data-toggle="modal" data-target="#privacy-policy">Privacy policy</a></p>
										    	  <i class="error-msg" v-if="$v.terms.$error">Please accept the terms.</i>
                      	</div>
											</div>
										</div>
									</div>
								</div>
								<div class="col-md-12">
									<div class="submit-btn">
										<button  :disabled="submitted" v-on:click.prevent="createAccount" type="submit" class="btn">Create Account</button>
										<label for="mobile-number" class="">
											<span class="sub-label">{{ sendingMessage }}</span>
										</label>
                  </div>
                    <br/>
								</div>
							</div>
						</form>
					</div>
				</div>
			</div>
      <TermsAndConditions/>
      <PaymentTerms/>
      <PrivacyPolicy/>
		</section>
</template>

<script>


import TermsAndConditions from "../components/TermsAndConditions";
import PaymentTerms from "../components/PaymentTerms";
import PrivacyPolicy from "../components/PrivacyPolicy";
import { required, minLength, between, email } from 'vuelidate/lib/validators'
import VueRecaptcha from "vue-recaptcha";


export default {
  name: 'InitiateAccount',
  components: { 
      VueRecaptcha,
      TermsAndConditions,
      PaymentTerms,
      PrivacyPolicy
  },
  data () {
    return {
      name: '',
      email: '',
      mobile: '',
      terms: false, 
      sendingMessage: "An SMS message will be sent with the confirmation code.",
      smsReceived: false, 
      submitted: false, //disable button when form submited
      smsCode: 0, 
      isPlatformActive: false,
      captcha:false
    }
  },
  validations: {
    name: {
      required,
      minLength: minLength(4)
    },
    email: {
      required,
      email
    },
    mobile: {
       required,
       minLength: minLength(10)
    },
    terms: {
       type: Boolean,
       required
    },
     captcha: {
       type: Boolean,
       required
    }
  },
  mounted () {
    this.$store.commit('setStepProgress', {step: 'default'})
    this.$store.commit('setFlowStatus',{flowCompleted: false, flowStatus: null});
    this.checkPlatformActive()
    console.log(this.$route.params)
    this.$store.state.platformName=this.$route.params.platformName
    this.$store.state.merchantId=this.$route.params.merchantId
    if(this.$NODE_ENV=='development'){
        this.name= "user" +this.$store.state.merchantId
        this.email= this.name+ "@go.com"
        this.mobile= '9999999999'
        this.terms= true
        this.captcha = true
    }
    localStorage.setItem('platformName', this.$route.params.platformName)
    localStorage.setItem('merchantId', this.$route.params.merchantId)
    localStorage.setItem('token',"")
    localStorage.setItem('isUserNew',"")
    localStorage.setItem('username',"")
    localStorage.setItem('identityCheck',"")
    localStorage.setItem('type',"")
    localStorage.setItem('account',"")
    localStorage.setItem('mobile',"")
  

    
    setTimeout(() => { 
        this.$refs.fullname.focus();
     }, 10);
   
  }, 
  methods: {
   getValidationClass (fieldName) {
        const field = this.$v[fieldName]
        if (field) {
          return field.$dirty && field.$invalid ? 'error-brdr' : field.$dirty && !field.$invalid  ? 'success-brdr' : ''   
        }
      },
    createAccount: function(event) {
      this.$v.$touch();
      if(!this.$v.$anyError){
        this.sendingMessage="SMS sent, please wait .."
        this.submitted=true
        this.getUiToken()
      }
      else {
           this.$toasted.show('There are form errors, please check',{
            type : 'error',
            duration : 3000,
            position: "top-right", 
        }) 
      }
    }, 

    getUiToken: function() {
      let that = this  
      let data = {
          "platformSlug": this.$route.params.platformName,
          "merchantId": this.$route.params.merchantId,
          "name": this.name,
          "email": this.email,
          "mobileNumber": this.mobile
        };
      this.$axios({
        "url": "/onboarding/accounts",
        "method": "POST",
        "headers": { "content-type": "application/json"},
        "data": data
      })
      .then(response => {
        console.log("initiate response",response);
        console.log(response.data)
        
        localStorage.setItem('token', response.data.token )
        localStorage.setItem('isUserNew', response.data.new )
        localStorage.setItem('username', response.data.username )
        localStorage.setItem('smsCode', response.data.smsCode )
        localStorage.setItem('mobile', this.mobile )

        if(this.$NODE_ENV=='development') {
          alert("Welcome " + this.name + " to Jupiter platform\n\nCODE: "+ response.data.smsCode + "\n\nThanks you! ")
        }

        this.smsReceived=true
        this.$store.commit('setStepProgress', {step: 1,status:  'progress'})
        this.$router.push({"name": "MobileCodeVerification"})

      })
      .catch(error => {
        console.log('error is .. ',error)
        this.submitted=false
        let logObject = {module: "onboarding",error: error, details: {page: "initiateAccount.getUiToken",endpoint: "/onboarding/accounts",data: data}};
        this.$store.commit('logError', logObject);
      })
    },

    checkPlatformActive: function(platform) {
      let that = this
      this.$axios({
        "url": "/onboarding/platforms/" + this.$route.params.platformName + "/status/",
        "method": "GET"
      })
      .then(response => {
        console.log('response is --- ',response);
        if(response.data.status!="active") {
          this.$router.push({"name": "InitiateFailure"})
        }
      })
      .catch(error => { //FABIAN LOGGING/ERROR/SAMPLE...
        console.log(error)
        let logObject = {module: "onboarding",error: error, details: {page: "initiateAccount.checkPlatformActive",endpoint: "/onboarding/platforms/UNDO/" + this.$route.params.platformName + "/status/",data: {} }};
        this.$store.commit('logError', logObject);
      })
    },
    onVerify: function (response) {
       this.$v.captcha.$model = true;
       this.captcha = true;
    },
    onExpired: function (response) {
      console.log('response after Expired ',response);
    },
  }
}
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>

</style>
